
/**
 * Beschreibt ein Fahrzeug.
 * 
 * @author Albert Wiedemann
 * @version 1.0
 */
class Fahrzeug
{
    /** Anzeigesymbol */
    protected FahrzeugSymbol symbol;
    /** Bewegungsdaten */
    protected int x;
    protected int y;
    protected double v;
    protected double vmax;

    /**
     * Erzeugt die Anzeige und setzt die Startdaten
     */
    Fahrzeug()
    {
        vmax = 13.89;
        v = vmax;
        x = 0;
        y = 0;
    }

    /**
     * Erzeugt eine zufällige Farbe für das Fahrzeug
     */
    protected String ZufallsfarbeErzeugen()
    {
        switch ((new java.util.Random()).nextInt(7))
        {
            case 0:
                return "rot";
            case 1:
                return "grün";
            case 2:
                return "blau";
            case 3:
                return "gelb";
            case 4:
                return "cyan";
            case 5:
                return "magenta";
            case 6:
                return "weiss";
            default:
                return "";
        }
    }
    
    /**
     * Setzt die Position des Fahrzeugs.
     * 
     * @param x x-Position
     * @param y y-Position
     */
    void PositionSetzen(int x, int y)
    {
        this.x = x;
        this.y = y;
        symbol.PositionSetzen(x, y);
    }
    
    /**
     * Fährt das Fahrzeug eine Sekunde nach oben.
     * @param wegmax maximaler Weg bis zum nächsten Hindernis (Ampel oder VOrgänger)
     * @param vvorg Geschwindigkeit des Vorgängerfahrzeugs bzw.der Ampel
     */
    void Fahren(int wegmax, double vvorg)
    {
    }        

    /**
     * Meldet die x-Koordinate zurück
     * @return x-Koordinate
     */
    int XKoordinateGeben()
    {
        return x;
    }

    /**
     * Meldet die y-Koordinate zurück
     * @return y-Koordinate
     */
    int YKoordinateGeben()
    {
        return y;
    }

    /**
     * Meldet die Länge des Fahrzeugs zurück
     * @return Länge
     */
    int LängeGeben()
    {
        return 0;
    }

    /**
     * Meldet die Geschwindigkeit zurück
     * @return Geschwindigkeit
     */
    double GeschwindigkeitGeben()
    {
        return v;
    }

    /**
     * Entfernt das Fahrzeug aus der Anzeige
     */
    void Entfernen()
    {
        symbol.Entfernen();
    }
}
