
import java.util.*;
/**
 * Beschreibt die in der Anzeige vorhandenen Setze-Methoden.
 * 
 * @author Albert Wiedemann 
 * @version 1.0
 */
interface AnzeigeInterface
{
    /**
     * Setzt den Namen der Handwaffe
     * @param name Name der Handwaffe
     */
    void HandwaffenNameSetzen (String name);

    /**
     * Setzt den Namen der Schutzwaffe
     * @param name Name der Schutzwaffe
     */
    void SchutzwaffenNameSetzen (String name);

    /**
     * Setzt die Stärkenanzeige
     * @param st Wert der Stärke
     */
    void StärkeSetzen (int st);

    /**
     * Setzt die Anzahl der Schlüssel
     * @param anz Anzahl
     */
    void SchlüsselAnzahlSetzen (int anz);
    
    /**
     * Setzt das Gesamtgewicht der Schätze
     * @param gewicht Gesamtgewicht
     */
    void GesamtgewichtSetzen (double gewicht);

    /**
     * Setzt die Liste der Spielerschätze
     * @param texte Namen der Schätze
     */
    void SpielerSchätzeSetzen (ArrayList<String> texte);
    
    /**
     * Setzt die Liste der Raumschätze
     * @param texte Namen der Schätze
     */
    void RaumSchätzeSetzen (ArrayList<String> texte);

    /**
     * Trägt den Monsternamen ein und blendet die nötigen Anzeigen für den Monsterkampf ein / aus.
     * @param text der Monstername
     */
    void RundeVerlorenSetzen (String text);

    /**
     * Beendet den Monsterkampf und blendet die nötigen Anzeigen ein / aus.
     */
    void KampfZuEndeSetzen ();
    
    /**
     * Fügt eine neue Botschaft an die Anzeige an.
     * @param text Botschaft
     */
    void NeueBotschaftEintragen (String text);

    /**
     * Löscht die Daten der Landkartenanzeige
     */
    void LandkartendatenLöschen();
    
    /**
     * Trägt neue Rauminformation in die Landkartenanzeige ein.
     */
    void RaumEintragen (LandkarteneintragRaum r);
    
    /**
     * Trägt neue Weginformation in die Landkartenanzeige ein.
     */
    void WegEintragen (LandkarteneintragWeg w);

    /**
     * Veranlasst das Neuzeichnen der Landkartenanzeige
     */
    void LandkarteNeuZeichnen();
    
    /**
     * Zeigt die Meldung über das erfolgreiche Spielende an.
     */
    void EndemeldungAnzeigen();
}
