
import java.util.*;
/**
 * Das Monster Falltür.
 * Der Spieler wird irgendwohin versetzt
 * 
 * @author Albert Wiedemann 
 * @version 1.0
 */
class Falltuer extends Monster
{

    /**
     * Der Konstruktor besetzt das Spiel
     * @param sp das Spiel, in dem das Objekt verwendet wird.
     */
    Falltuer (Spiel sp)
    {
        super (sp);
    }

    /**
     * Meldet den Namen des Objekts zurück
     * @return name
     */
    @Override protected String NameGeben()
    {
        return "Falltür";
    }
    
    /**
     * Einleitung des Kampfs.
     * @param sp der angegriffene Spieler
     */
    @Override protected void KampfBeginnen (Spieler sp)
    {
        new Falle (sp.wo);
    }
    
    /**
     * Kampf des Spielers mit dem Monster
     * @param sp der angegriffene Spieler
     * @return wahr, wenn der Spieler den Kampf gewonnen hat.
     */
    @Override protected boolean KampfDurchführen (Spieler sp)
    {
        return true;
    }

    class Falle extends Tueren
    {
        /** die ursprünglichen Türen */
        Tueren türen;
        /** der betroffene Raum */
        Raum woher;
        
        /**
         * Merkt sich die Situation.
         */
        Falle (Raum woher)
        {
            super();
            this. woher = woher;
            türen = woher.türen;
        }
        
        /**
         * Meldet, ob das Ziel der einegene Raum oder ein Nachbarraum ist
         * @param eigener Raum
         * @return 
         */
        private boolean ZielZunahe (Raum ziel)
        {
            if (ziel == woher)
            {
                return true;
            }
            for (Raum wohin: türen.türen)
            {
                if (wohin == ziel)
                {
                    return true;
                }
            }
            return false;
        }
        
        /**
         * Prüft, ob es eine Tür zum Raum mit der angegebenen Nummer gibt
         * @param nummer die Raumnummer
         * @return Raum oder null
         */
        @Override protected Raum TürNachGeben (int nummer)
        {
            Raum hilf = türen.TürNachGeben(nummer);
            if (!(woher. monster instanceof Falltuer))
            {
                woher.türen = türen;
            }
            else if (hilf != null)
            {
                spiel.BotschaftSenden("Schönen Gruß von der Falltür.");
                woher.türen = türen;
                do
                    hilf = woher.ZufallsRaumGeben(50);
                while (ZielZunahe (hilf));
            }
            return hilf;
        }
        
        /**
         * Meldet die Anzahl der Türen
         * @return Türenzahl
         */
        @Override protected int AnzahlTürenGeben ()
        {
            return türen.AnzahlTürenGeben();
        }
    
        /**
         * Meldet die Tür mit der angegebenen Nummer.
         * @param nummer die Türnummer
         * @return Raum
         */
        @Override protected Raum TürNummerGeben (int nummer)
        {
            return türen.TürNummerGeben(nummer);
        }
    }
}
