
/**
 * Der Kontroller verbindet die Programmlogik mit der Oberfläche.
 * 
 * @author Albert Wiedemann 
 * @version 1.0
 */
class Kontroller implements KontrollerInterface
{
    /** Das aktuell anstehende Kommando */
    Kommandos aktKommando;
    /** Der aktuell anstehende Kommandoparameter */
    int aktKommandoparam;
    /** Zwischensicherung für den Kommandoparameter */
    int aktKommandoparamSicherung;

    /**
     * Constructor for objects of class Kontroller
     */
    Kontroller ()
    {
        aktKommando = Kommandos.keinKommando;
        aktKommandoparam = 0;
        aktKommandoparamSicherung = 0;
    }
    
    /**
     * Trägt ein neues Kommado ein, falls nicht noch eines zur Verarbeitung ansteht.
     * @param kdo das einzutragende Kommando
     * @param param der Kommandoparameter
     */
    synchronized void KommandoEintragen (Kommandos kdo, int param)
    {
        if (aktKommando == Kommandos.keinKommando)
        {
            aktKommando = kdo;
            aktKommandoparam = param;
        }
        notify();
    }
    
    /**
     * Meldet das anstehende Kommando
     * @return Kommando
     */
    public synchronized Kommandos KommandoGeben()
    {
        Kommandos res;
        while (aktKommando == Kommandos.keinKommando)
        {
            try
            {
                wait();
            }
            catch (Exception e)
            {
                //nix
            }
        }
        res = aktKommando;
        aktKommandoparamSicherung = aktKommandoparam;
        aktKommando = Kommandos.keinKommando;
        return res;
    }
    
    /**
     * Meldet den zum Kommando gehörenden Parameterwert.
     * @return Kommandoparameter
     */
    public int KommandoParameterGeben()
    {
        return aktKommandoparamSicherung;
    }
    
}
